// screen4.c - Fourth MTXLib demonstration screen

#include <stdio.h>
#include <string.h>
#include <diskio.h>
#include <mtxscrn.h>

void Dump (void *data, unsigned int len);

void Dir (const char *psDir)
    {
    FCB fcb;
    unsigned char buf[128];
    printf ("Dir %s\r\n", psDir);
    unsigned char *pdir = findfirst (&fcb, buf, psDir);
    while ( pdir != NULL )
        {
        for (int i = 0; i < 8; ++i)
            {
            ++pdir;
            putchar (*pdir);
            }
        putchar ('.');
        for (int i = 0; i < 3; ++i)
            {
            ++pdir;
            putchar (*pdir);
            }
        putchar (' ');
        pdir = findnext ();
        }
    printf ("\r\n");
    }

void screen4 (void)
    {
    FCB fcb;
    unsigned char buf[128];
    cls ();
    strcpy (buf, "Test disk I/O\r\n.");
    Dump (buf, 16);
    printf ("Create file = %d\r\n", make (&fcb, "TEST1.TMP"));
    printf ("Write file = %d\r\n", write (&fcb, buf));
    strcpy (buf, "Second record.\r\n");
    Dump (buf, 16);
    printf ("Write random = %d\r\n", randwr (&fcb, buf, 1));
    printf ("Close file = %d\r\n", close (&fcb));
    Dir ("*.TMP");
    printf ("Rename file = %d\r\n", rename (&fcb, "TEST1.TMP", "TEST2.TMP"));
    Dir ("*.TMP");
    printf ("Press a key ...\r\n");
    getchar ();
    printf ("Clear buffer\r\n");
    memset (buf, 0, 16);
    Dump (buf, 16);
    printf ("Open file = %d\r\n", open (&fcb, "TEST2.TMP"));
    printf ("Read file = %d\r\n", read (&fcb, buf));
    Dump (buf, 16);
    printf ("Read random = %d\r\n", randrd (&fcb, buf, 1));
    Dump (buf, 16);
    printf ("Close file = %d\r\n", close (&fcb));
    printf ("Delete file = %d\r\n", delete (&fcb, "TEST2.TMP"));
    Dir ("*.TMP");
    printf ("Screen 4\r\n");
    }
